## dose3 3.0.2

=== Makefile ===
include Makefile.config

DIST_DIR = $(NAME)-$(VERSION)
DIST_TARBALL = $(DIST_DIR).tar.gz

OBFLAGS := -j 10 -classic-display
#OBFLAGS := $(OBFLAGS) -tag debug -tag profile
#OBFLAGS := $(OBFLAGS) -classic-display

realall: $(BYTELIBS) $(ALIBS) $(OPTLIBS) $(CMXSLIBS) man
	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)

fast: $(OPTLIBS)
	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)

apps:
	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)

DOSELIBS = _build/doselibs

cudf/cudf.%:
	$(OCAMLBUILD) $(OBFLAGS) cudf/cudf.$*
	@mkdir -p $(DOSELIBS)
	@cp _build/cudf/*.cmi $(DOSELIBS)
	@for i in _build/cudf/cudf.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

common/common.%:
	$(OCAMLBUILD) $(OBFLAGS) common/common.$*
	@mkdir -p $(DOSELIBS)
	@for i in _build/common/common.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

algo/algo.%:
	$(OCAMLBUILD) $(OBFLAGS) algo/algo.$*
	@for i in _build/algo/algo.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

deb/debian.%:
	$(OCAMLBUILD) $(OBFLAGS) deb/debian.$*
	@for i in _build/deb/debian.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

rpm/rpm.%:
	$(OCAMLBUILD) $(OBFLAGS) rpm/rpm.$*
	@for i in _build/rpm/rpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

eclipse/eclipse.%:
	$(OCAMLBUILD) $(OBFLAGS) eclipse/eclipse.$*
	@for i in _build/eclipse/eclipse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

opencsw/csw.%:
	$(OCAMLBUILD) $(OBFLAGS) opencsw/csw.$*
	@for i in _build/opencsw/csw.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

doseparse/boilerplate.%:
	$(OCAMLBUILD) $(OBFLAGS) doseparse/boilerplate.$*
	@for i in _build/doseparse/boilerplate.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx $(DOSELIBS)/*.ml ; \
	  fi ; \
	done

doseparse/boilerplateNoRpm.%:
	$(OCAMLBUILD) $(OBFLAGS) doseparse/boilerplateNoRpm.$*
	@for i in _build/doseparse/boilerplateNoRpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

POD = $(wildcard doc/manpages/*.pod)
POD5 = doc/manpages/apt-cudf.conf.pod
POD8 = doc/manpages/apt-cudf-get.pod
POD1 = $(filter-out $(POD5) $(POD8),$(POD))
MAN = $(patsubst %.pod,%.1,$(POD1)) $(patsubst %.pod,%.5,$(POD5)) $(patsubst %.pod,%.8,$(POD8))
HTML = $(patsubst %.pod,%.html,$(POD))

man: $(MAN)
html: $(HTML)
	mkdir -p dose3.docdir/manpages
	cp doc/manpages/*.html dose3.docdir/manpages

doc/manpages/%.1: doc/manpages/%.pod
	pod2man --section 1 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@

doc/manpages/%.5: doc/manpages/%.pod
	pod2man --section 5 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@

doc/manpages/%.8: doc/manpages/%.pod
	pod2man --section 8 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@

doc/manpages/%.html: doc/manpages/%.pod
	pod2html doc/manpages/$*.pod > $@

clean:
	$(OCAMLBUILD) -clean
	@echo ""
	rm -f doc/manpages/*.[158] doc/manpages/*.html

distclean: clean
	rm -Rf Makefile.config aclocal.m4 config.log config.status autom4te.cache/
	rm -f algo/algo.mlpack
	rm -f common/versionInfo.ml
	rm -f db/db.mlpack
	rm -f _tags META
	rm -f doc/manpages/*.1

$(DOSELIBS)/%:
	$(OCAMLBUILD) $(OBFLAGS) $*
	@touch $@

testapps: apps 
	@applications/dose-tests.py -pwd `pwd` -v

testlib: 
	@for i in $(TESTS); do\
		echo "#######TESTING $$i" ;\
		$(OCAMLBUILD) $(OBFLAGS) $$i/tests.$(OCAMLBEST) ;\
		./tests.$(OCAMLBEST) ;\
	done
	@make apps

test: testapps testlib

# stuff not not put in a distribution tarball
DIST_EXCLUDE = cudf tests $(wildcard */tests) experimental

INSTALL_STUFF_ = META
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
INSTALL_STUFF_ += $(wildcard _build/rpm/*.so _build/rpm/*.a)

exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
INSTALL_STUFF = $(filter-out $(exclude_cudf), $(INSTALL_STUFF_))

install: META installcudf
	test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	test -d $(LIBDIR)/stublibs || mkdir -p $(LIBDIR)/stublibs
	$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)

	# install applications
	cd _build/applications ; \
	install -d $(BINDIR) ; \
	for f in $$(ls *.$(OCAMLBEST)) ; do \
	  install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLBEST)} ; \
	done
	ln -s $(BINDIR)/distcheck $(BINDIR)/debcheck
	ln -s $(BINDIR)/distcheck $(BINDIR)/rpmcheck
	ln -s $(BINDIR)/distcheck $(BINDIR)/eclipsecheck

uninstall: uninstallcudf
	$(OCAMLFIND) remove -destdir $(LIBDIR) $(NAME)

	for f in $$(ls *.$(OCAMLBEST)) ; do \
	  rm -f $(BINDIR)/$${f%.$(OCAMLBEST)} ; \
	done
	rm -f $(BINDIR)/debcheck $(BINDIR)/rpmcheck $(BINDIR)/eclipsecheck

dist: ./$(DIST_TARBALL)
./$(DIST_TARBALL):
	if [ -d ./$(DIST_DIR)/ ] ; then rm -rf ./$(DIST_DIR)/ ; fi
	if [ -d ./$(DIST_TARBALL) ] ; then rm -f ./$(DIST_TARBALL) ; fi
	if [ -d .svn ]; then \
	  svn export . ./$(DIST_DIR) ; \
	else \
	  mkdir ./$(DIST_DIR)/ ; git archive --format=tar HEAD | tar -x -C ./$(DIST_DIR)/ ; \
	fi
	for f in $(DIST_EXCLUDE) ; do rm -rf ./$(DIST_DIR)/$$f; done
	tar cvzf ./$(DIST_TARBALL) ./$(DIST_DIR)
	rm -rf ./$(DIST_DIR)
	@echo "Distribution tarball: ./$(DIST_TARBALL)"

changelog:
	dch -c CHANGES --package $(NAME) -v $(VERSION)

credits:
	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';

doc: fast
	$(OCAMLBUILD) $(OBFLAGS) dose3.docdir/index.html dose3.docdir/index.dot
	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
	$(MAKE) man
	$(MAKE) html

.PHONY: all opt clean top-level headers test tags install uninstall dist doc

=== doc/apt-external-solvers.primer/Makefile ===
NAME = apt-external-solvers
DEPS = $(wildcard *.tex)
DEPS += build-pics-stamp
DEPS += build-tables-stamp

all: pdf
pdf: $(NAME).pdf
dvi: $(NAME).dvi
$(NAME).pdf $(NAME).dvi: $(DEPS)
show: showpdf
showpdf: $(NAME).pdf
	xdg-open $<
showdvi: $(NAME).dvi
	xdvi $<

build-pics-stamp: $(wildcard pics/*.dia pics/*.dot)
	touch $@

build-tables-stamp: $(wildcard competition/*.tbl)
	touch $@
clean::
	-rm -f build-pics-stamp build-tables-stamp

# Debian package: latex-make
include /usr/include/LaTeX.mk

=== doc/debcheck-primer/Makefile ===
MAIN=debcheck-primer
SHELL=/bin/bash
HEVEA=hevea -exec xxdate.exe
DEPS = $(wildcard *.tex) version.tex mancoosi.bib

default: $(MAIN).html 

include ../../Makefile.config

$(MAIN).html: $(DEPS) $(MAIN).aux
	bibtex $(MAIN)	
	$(HEVEA) -fix $(MAIN).tex

$(MAIN).ps: $(MAIN).dvi
	dvips $<

$(MAIN).dvi: $(DEPS)
	latex $(MAIN)

$(MAIN).aux: $(DEPS)
	latex $(MAIN)

version.tex:
	echo -n "\\def\\version{" >> $@
	echo -n $(VERSION) >> $@
	echo "}" >> $@

headers:
	headache -h headache.header -c headache.conf $(DEPS)

clean:
	-rm -f $(MAIN).{dvi,aux,toc,haux,htoc,log,bbl,blg} version.tex

veryclean: clean
	-rm -f $(MAIN).{html,ps}	

.phony: clean realclean headers

=== doc/multi-arch-encoding/Makefile ===
NAME = main
DEPS = $(wildcard *.tex)
DEPS += build-pics-stamp
DEPS += build-tables-stamp

all: pdf
pdf: $(NAME).pdf
dvi: $(NAME).dvi
$(NAME).pdf $(NAME).dvi: $(DEPS)
show: showpdf
showpdf: $(NAME).pdf
	xdg-open $<
showdvi: $(NAME).dvi
	xdvi $<

build-pics-stamp: $(wildcard pics/*.dia pics/*.dot)
	touch $@

build-tables-stamp: $(wildcard competition/*.tbl)
	touch $@
clean::
	-rm -f build-pics-stamp build-tables-stamp

# Debian package: latex-make
include /usr/include/LaTeX.mk

=== debian/changelog ===
dose3 (3.0.2-3) unstable; urgency=low

  * Upload to unstable.

 -- Ralf Treinen <treinen@debian.org>  Wed, 03 Oct 2012 19:25:40 +0200

dose3 (3.0.2-2) experimental; urgency=low

  * Patch multiarch-conflicts: fix the translation of conflicts in case of
    multiarchs, a conflict on package p has to apply to p of all possible
    architectures. (closes: #685171). Patch extracted from the
    3.0.2-hotfix branch of the upstream git repository (commit
    a2f69265323d8cead088eeee2a731db582d3cc81). Thanks to Pietro Abate for
    having fixed this.
  * Patch apt-cudf-pinning: Fix version numbers in the package installation
    requests in the translation process from EDSP to CUDF (closes: #687643).
    Thanks to Pietro Abate for the patch!
  * Patch builddebcheck-manpage: Fix architecture options in the
    dose-builddebcheck manpage (closes: #680271).

 -- Ralf Treinen <treinen@debian.org>  Wed, 26 Sep 2012 17:21:15 +0200

dose3 (3.0.2-1) unstable; urgency=low

  * New upstream version:
    - Remove patch manpage-distcheck which has been applied upstream
  * debian/copyright:
    - fix continuation lines in the paragraph for connection-licence.
    - fix typo Licence -> License
  * debian/rules: in clean target, remove doc/debcheck-primer/version.tex
    since it should be generated.
  * fix the version number that upstream forgot to bump:
    - add patch version-3.0.2
    - add automake and autoconf to build-dependencies
    - call aclocal and autconf in the configure target of debian/rules

 -- Ralf Treinen <treinen@debian.org>  Wed, 27 Jun 2012 11:24:15 +0200

dose3 (3.0.1-1) unstable; urgency=low

  * New upstream version
  * Remove patch manpages-section5 which has been applied by upstream
  * Install upstream's version of apt-cudf-get script and manpage, drop our
    version in debian/
  * Patch manpage-distcheck: some improvements to distcheck manpage.
  * debian/copyright:
    - put files paragraph with more general file pattern first
    - add BSD-ish license for db/sqlite/sqlitext/connection.h
      (thanks to Ansgar Burchardt for the remark).

 -- Ralf Treinen <treinen@debian.org>  Sun, 17 Jun 2012 19:58:39 +0200

dose3 (2.9.17-1) unstable; urgency=low

  * New upstream version.
    - refreshed patch binaries-prefix-edos
  * New file debian/apt-cudf.conf, install into /etc
  * debian/apt-cudf.manpages: install apt-cudf.conf
  * patch manpages-section5: apt-cudf.conf manpage is section 5 not 1
  * debian/rules: deactivate dh_auto_test for now as the upstream tarball
    does not contain the necessary data for the tests.
  * New file debian/apt-cudf-get, install into /usr/bin
  * Write a manpage for apt-cudf-get, install in the apt-cudf package.

 -- Ralf Treinen <treinen@debian.org>  Thu, 31 May 2012 22:35:14 +0200

dose3 (2.9.15-1) unstable; urgency=low

  * New upstream version. This version fixes a bug in the printing of
    debian package versions (closes: #665378)
  * Remove patch dont-strip-bytecode, now integrated by upstream.

 -- Ralf Treinen <treinen@debian.org>  Fri, 30 Mar 2012 15:29:07 +0200

dose3 (2.9.14-3) unstable; urgency=low

  * fix a typo in long description of dose-extra
  * put an empty directory /usr/lib/apt/solvers into the apt-cudf package
    so that dpkg knows it has to remove it on package removal.
    (closes: #664860)

 -- Ralf Treinen <treinen@debian.org>  Wed, 21 Mar 2012 21:00:31 +0100

dose3 (2.9.14-2) unstable; urgency=low

  * patch dont-strip-bytecode: install must not try to strip executables
    when compilation to bytecode. Fixes an FTBFS on architectures with
    compilation to bytecode.

 -- Ralf Treinen <treinen@debian.org>  Sat, 17 Mar 2012 19:24:48 +0100

dose3 (2.9.14-1) unstable; urgency=low

  * New upstream version
    - ported patch binaries-prefix-edos to the new upstream version
  * debian/control: add {$perl:Depends} to dependencies of apt-cudf
    (closes: Bug#659834)
  * debian/control: use Conflicts and Removes to remove old versions of
    binary packages from before the renaming:
    - dose-distcheck conflicts with dose3-distcheck
    - dose-builddebcheck conflicts with dose3-builddebcheck
  * Rename ceve to dose-ceve (binary and manpage)
  * Standards-Version 3.9.3
    - debian/copyright: machine readable format 1.0
  * package libdose3-ocaml: only install files dll*stubs.so
  * build and install the debcheck primer:
    - debian/control: add build-dependency on hevea, texlive-latex-base,
      texlive-latex-extra
    - debian/rules: compile the primer
    - add debian/dose-distchecks.{docs, doc-base}

 -- Ralf Treinen <treinen@debian.org>  Fri, 16 Mar 2012 19:31:34 +0100

dose3 (2.9.13-1) experimental; urgency=low

  * New upstream release - now almost ready for sid!
  * The ceve package has disappeared, we have instead now a new package
    dose-extra that contains all tools that do not deserve their own
    package (for the moment: ceve, outdated, challenged).
  * Packages for distcheck and builddebcheck have prefix dose- now.
    Binaries (except ceve and apt-cudf) also have prefix dose.
  * debian/rules:
    - configuration option --with-rpm has become --with-rpm4
    - upstream has fixed installation of algo.a, we can now remove our own
      hack in override_auto_install.
  * debian/control:
    - The apt-cudf package now depends first on aspcud before the virtual
      package cudf-solver
    - add ${shlibs:Depends} to dependencies of libdose3-ocaml-dev
    - Bump build-dependency on cudf to 0.6.2
    - Added build-dependency on perl needed for building the manpages
      using pod2man, and on graphviz which is needed to build the
      dependency graph of modules in the documentation.
  * generate documentation with ocamldoc (make doc) and install it in the
    libdose3-ocaml-dev package. Add an doc-base entry for the documentation.
  * debian/copyright: update (files common/url.ml, deb/version.ml)

 -- Ralf Treinen <treinen@debian.org>  Tue, 07 Feb 2012 21:41:12 +0100

dose3 (2.9.8-1) experimental; urgency=low



=== debian/control ===
Source: dose3
Section: ocaml
Priority: extra
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stefano Zacchiroli <zack@debian.org>,
 Ralf Treinen <treinen@debian.org>
Build-Depends: debhelper (>= 7.0.50~), dh-ocaml (>= 0.9~),
 automake, autoconf,
 ocaml-nox (>= 3.11.1-3~), camlp4,
 libpcre-ocaml-dev,
 libextlib-ocaml-dev,
 libocamlgraph-ocaml-dev,
 libcudf-ocaml-dev (>= 0.6.2),
 libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.8),
 perl, graphviz, hevea, texlive-latex-base, texlive-latex-extra
Standards-Version: 3.9.3
Homepage: http://www.mancoosi.org/software/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/dose3.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/dose3.git

Package: libdose3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (development files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains the development stuff you need to use dose3 for
 the development of programs.

Package: libdose3-ocaml
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends} 
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (runtime files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains only the shared runtime stub libraries.

Package: dose-distcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Conflicts: dose3-distcheck (<< 2.9.13)
Replaces: dose3-distcheck (<< 2.9.13)
Description: Checks whether dependencies of packages can be satisfied
 This software checks for every package of a distribution whether it
 is possible to satisfy its dependencies and conflicts within this
 distribution. It comes in several versions:
  - dose-debcheck for Debian packages
  - dose-rpmcheck for rpm packages
  - dose-eclipsecheck for OSGi plugins

Package: dose-builddebcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Conflicts: dose3-builddebcheck (<< 2.9.13)
Replaces: dose3-builddebcheck (<< 2.9.13)
Description: Checks whether build-dependencies can be satisfied
 This software checks, given a collection of source package stanzas
 and a collection of binary package stanzas of debian packages, whether
 the build-dependencies of each source package can be satisfied by the
 binary packages.

Package: dose-extra
Section: devel
Architecture: any
Provides: ceve
Conflicts: ceve (<< 2.9.10)
Replaces: ceve (<< 2.9.10)
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Extra QA tools from the Dose3-library
 This package contains extra tools for analyzing meta-data of software 
 packages:
  - ceve, a general metadata parser supporting different input formats
    (debian, rpm, and others) and different output formats.
  - dose-outdated, a debian-specific tool for finding packages that are not
    installable with respect to a package repository, and that can only be
    made installable again by fixing the package itself.
  - dose-challenged, a debian-specific tool for checking which packages
    will certainly become uninstallable when some existing package is upgraded
    to a newer version.
 The tools dose-distcheck and dose-builddebcheck are packaged in their
 own resepective packages.

Package: apt-cudf
Section: admin
Architecture: any
Depends: aspcud | cudf-solver,
 ${ocaml:Depends}, ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: CUDF solver integration for APT
 apt-cudf provides integration among the APT package manager and CUDF solvers,
 allowing APT to rely on external (CUDF-based) dependency solvers to plan
 package installation, upgrade, and removal.
 .
 CUDF is a distribution-independent, standard format to describe dependency
 solving scenarios, as faced by package managers in popular package-based
 GNU/Linux distributions. APT is a well-known package manager for Debian-based
 distributions, which is able to delegate dependency solving to external
 solvers, by the means of the External Dependency Solving Protocol (EDSP).
 .
 apt-cudf provides the glue between the EDSP protocol and CUDF solvers,
 enabling any installed CUDF solver to be used as an external solver for APT.
 .
 Several CUDF solvers are available in Debian. They all provide the cudf-solver
 virtual package.

=== debian/rules ===
#!/usr/bin/make -f

RELEASE = $(shell dpkg-parsechangelog | grep ^Version: | cut -f 2 -d' ')
%:
	dh $@ --with ocaml

override_dh_auto_configure:
	rm -f doc/debcheck-primer/version.tex
	aclocal -I m4
	autoconf
	./configure --with-ocamlgraph --with-zip --with-bz2 --with-rpm4

override_dh_auto_install:
	dh_auto_install
	cd debian/tmp/usr/bin \
		&& mv distcheck dose-distcheck \
		&& mv deb-buildcheck dose-builddebcheck \
		&& mv outdated dose-outdated \
		&& mv challenged dose-challenged \
		&& mv ceve dose-ceve

override_dh_installman:
	dh_installman
	cd debian/dose-distcheck/usr/share/man/man1 \
		&& mv distcheck.1 dose-distcheck.1
	cd debian/dose-extra/usr/share/man/man1 \
		&& mv outdated.1 dose-outdated.1 \
		&& mv challenged.1 dose-challenged.1 \
		&& mv ceve.1 dose-ceve.1 
	cd debian/dose-builddebcheck/usr/share/man/man1 \
		&& mv buildcheck.1 dose-builddebcheck.1

override_dh_auto_build:
	dh_auto_build
	$(MAKE) doc
	cd doc/debcheck-primer && $(MAKE) 
	pod2man --section 8 -release "apt-cudf $(RELEASE)" \
		debian/update-cudf-solvers > debian/update-cudf-solvers.8

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/update-cudf-solvers.8
	rm -f _tags

override_dh_auto_test:
	# do nothing

=== debian/watch ===
version=3
http://gforge.info.ucl.ac.be/frs/?group_id=35 .*/dose3-(.*)\.tar\.gz

## dose3 3.1.3

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,6 @@
+#this is a forward reference to the target all below
+all: all
+
 include Makefile.config
 
 DIST_DIR = $(NAME)-$(VERSION)
@@ -7,16 +10,20 @@
 #OBFLAGS := $(OBFLAGS) -tag debug -tag profile
 #OBFLAGS := $(OBFLAGS) -classic-display
 
-realall: $(BYTELIBS) $(ALIBS) $(OPTLIBS) $(CMXSLIBS) man
+all: $(CAMLP4CMXS) $(BYTELIBS) $(ALIBS) $(OPTLIBS) $(CMXSLIBS) man
 	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)
 
-fast: $(OPTLIBS)
+fast: $(CAMLP4CMXS) $(OPTLIBS)
 	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)
 
 apps:
 	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)
 
 DOSELIBS = _build/doselibs
+
+camlp4cmxs:
+	mkdir -p _build
+	ocamlopt -shared $(shell ocamlc -where)/camlp4/Camlp4Parsers/Camlp4MacroParser.cmx -o _build/Camlp4MacroParser.cmxs
 
 cudf/cudf.%:
 	$(OCAMLBUILD) $(OBFLAGS) cudf/cudf.$*
@@ -102,34 +109,10 @@
 	  fi ; \
 	done
 
-POD = $(wildcard doc/manpages/*.pod)
-POD5 = doc/manpages/apt-cudf.conf.pod
-POD8 = doc/manpages/apt-cudf-get.pod
-POD1 = $(filter-out $(POD5) $(POD8),$(POD))
-MAN = $(patsubst %.pod,%.1,$(POD1)) $(patsubst %.pod,%.5,$(POD5)) $(patsubst %.pod,%.8,$(POD8))
-HTML = $(patsubst %.pod,%.html,$(POD))
-
-man: $(MAN)
-html: $(HTML)
-	mkdir -p dose3.docdir/manpages
-	cp doc/manpages/*.html dose3.docdir/manpages
-
-doc/manpages/%.1: doc/manpages/%.pod
-	pod2man --section 1 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@
-
-doc/manpages/%.5: doc/manpages/%.pod
-	pod2man --section 5 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@
-
-doc/manpages/%.8: doc/manpages/%.pod
-	pod2man --section 8 --center="DOSE Tools" --release "$(NAME) $(VERSION)" doc/manpages/$*.pod > $@
-
-doc/manpages/%.html: doc/manpages/%.pod
-	pod2html doc/manpages/$*.pod > $@
-
 clean:
 	$(OCAMLBUILD) -clean
 	@echo ""
-	rm -f doc/manpages/*.[158] doc/manpages/*.html
+	cd doc && $(MAKE) clean
 
 distclean: clean
 	rm -Rf Makefile.config aclocal.m4 config.log config.status autom4te.cache/
@@ -137,7 +120,6 @@
 	rm -f common/versionInfo.ml
 	rm -f db/db.mlpack
 	rm -f _tags META
-	rm -f doc/manpages/*.1
 
 $(DOSELIBS)/%:
 	$(OCAMLBUILD) $(OBFLAGS) $*
@@ -215,7 +197,13 @@
 doc: fast
 	$(OCAMLBUILD) $(OBFLAGS) dose3.docdir/index.html dose3.docdir/index.dot
 	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
-	$(MAKE) man
-	$(MAKE) html
-
-.PHONY: all opt clean top-level headers test tags install uninstall dist doc
+	(cd doc && $(MAKE) all)
+
+man:
+	cd doc/manpages && $(MAKE)
+
+upload: doc
+	(cd doc && $(MAKE) upload)
+	rsync -avz dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/
+
+.PHONY: all opt clean top-level headers test tags install uninstall dist doc man

=== db/Makefile ===
NAME = nappe
VERSION = 0.1

LIBS = _build/db.cma
LIBS_OPT = _build/db.cmxa
RESULTS = $(LIBS)
RESULTS_OPT = $(LIBS_OPT)
SOURCES = $(wildcard *.ml *.mli)

OCAMLBUILD = ocamlbuild
# OBFLAGS = -classic-display
OBFLAGS =
OCAMLFIND = ocamlfind

DESTDIR =
LIBDIR = $(DESTDIR)/$(shell ocamlc -where)
BINDIR = $(DESTDIR)/usr/bin
COLLDIR = $(DESTDIR)/usr/lib/sqlite3
ifeq ($(DESTDIR),)
INSTALL = $(OCAMLFIND) install
UNINSTALL = $(OCAMLFIND) remove
else
INSTALL = $(OCAMLFIND) install -destdir $(LIBDIR)
UNINSTALL = $(OCAMLFIND) remove -destdir $(LIBDIR)
endif

all: $(RESULTS) $(RESULTS_OPT) sqlite
opt: $(RESULTS_OPT) sqlite
$(RESULTS): $(SOURCES)
$(RESULTS_OPT): $(SOURCES)

sqlite: 
	cd sqlite && make

clean:
	make -C sqlite clean
	$(OCAMLBUILD) $(OBFLAGS) -clean

_build/%:
	$(OCAMLBUILD) $(OBFLAGS) $*
	@touch $@

headers: header.txt .headache.conf
	headache -h header.txt -c .headache.conf $(SOURCES) $(C_LIB_SOURCES)

INSTALL_STUFF = META
INSTALL_STUFF += $(wildcard _build/*.cma _build/*.cmxa _build/*.a)
INSTALL_STUFF += $(wildcard *.mli)

INSTALL_STUFF += $(wildcard _build/db.o _build/db.cmx _build/db.cmi)

install:
	test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)
	test -d $(COLLDIR) || mkdir -p $(COLLDIR)
	if [ -f sqlite/libcollate_debian.so  ] ; then \
		cp sqlite/libcollate_debian.so  $(COLLDIR) ; \
	fi
	@echo "Installed $(COLLDIR)/libcollate_debian.so "

uninstall:
	$(UNINSTALL) $(NAME)
	if [ -f $(COLLDIR)/libcollate_debian.so  ] ; then \
		rm $(COLLDIR)/libcollate_debian.so  ; \
		rmdir $(COLLDIR) ; \
	fi
	@echo "Removed $(COLLDIR)/libcollate_debian.so "

.PHONY: all clean headers sqlite

=== doc/Makefile ===
SUBDIRS = manpages debcheck.primer apt-external-solvers.primer
SHELL=/bin/bash

all:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE)); \
	done

clean:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE) clean); \
	done

webpages:
	cd webpages && $(MAKE) rebuild

upload: webpages
	rsync -avz --no-perms manpages/*.html scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/man/
	rsync -avz --no-perms debcheck.primer/*.{html,pdf} scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/tools/
	rsync -avz --no-perms webpages/public_html/* scm.gforge.inria.fr:/home/groups/dose/htdocs/public_html

=== db/sqlite/Makefile ===

all:
	$(CXX) $(CPPFLAGS) $(LDFLAGS) -lapt-pkg -fPIC -shared -o libcollate_debian.so debian_collation.cpp
	cd sqlitext && make
	cp sqlitext/sqlitext.py sqlitext/_sqlitext.so .

clean:
	rm -f *.pyc
	rm -f libcollate_debian.so
	cd sqlitext && make clean
	rm -f sqlitext.py _sqlitext.so

=== doc/debcheck.primer/Makefile ===
MAIN=debcheck-primer
SHELL=/bin/bash
HEVEA=hevea -exec xxdate.exe
DEPS = $(wildcard *.tex) version.tex mancoosi.bib

all: html ps pdf

include ../../Makefile.config

html: $(MAIN).html 

ps: $(MAIN).ps

pdf: $(MAIN).pdf


$(MAIN).html: $(DEPS) $(MAIN).aux
	bibtex $(MAIN)	
	$(HEVEA) -fix $(MAIN).tex

$(MAIN).ps: $(MAIN).dvi
	dvips $<

$(MAIN).pdf: $(DEPS)
	pdflatex $(MAIN)

$(MAIN).dvi: $(DEPS)
	latex $(MAIN)

$(MAIN).aux: $(DEPS)
	latex $(MAIN)

version.tex:
	echo -n "\\def\\version{" >> $@
	echo -n $(VERSION) >> $@
	echo "}" >> $@

headers:
	headache -h headache.header -c headache.conf $(DEPS)

distclean clean:
	-rm -f $(MAIN).{dvi,aux,toc,haux,htoc,log,bbl,blg,html,ps,pdf}\
		 version.tex

.phony: clean distclean headers all ps pdf html

=== doc/multi-arch-encoding/Makefile ===
--- 
+++ 
@@ -2,16 +2,21 @@
 DEPS = $(wildcard *.tex)
 DEPS += build-pics-stamp
 DEPS += build-tables-stamp
+HEVEA=hevea -exec xxdate.exe
 
 all: pdf
 pdf: $(NAME).pdf
 dvi: $(NAME).dvi
+html: $(NAME).html
 $(NAME).pdf $(NAME).dvi: $(DEPS)
 show: showpdf
 showpdf: $(NAME).pdf
 	xdg-open $<
 showdvi: $(NAME).dvi
 	xdvi $<
+
+$(NAME).html: $(DEPS) $(NAME).aux
+	$(HEVEA) -fix $(NAME).tex
 
 build-pics-stamp: $(wildcard pics/*.dia pics/*.dot)
 	touch $@

=== doc/webpages/Makefile ===
all: refresh
refresh:
	ikiwiki --setup local.setup --verbose --refresh

rebuild:
	ikiwiki --setup local.setup --verbose --rebuild

.phony: refresh rebuild

=== db/sqlite/sqlitext/Makefile ===
# FreeBSD
CFLAGS=-I/usr/local/include
LDFLAGS=-L/usr/local/lib
# CFLAGS=""
# LDFLAGS=""

all:
	swig -python sqlitext.i
	CFLAGS=$(CFLAGS) LDFLAGS=$(LDFLAGS) python setup.py build_ext --inplace

clean:
	python setup.py clean -a
	rm -f _sqlitext.so sqlitext.py sqlitext_wrap.c sqlitext.pyc

=== debian/changelog ===
dose3 (3.1.3-7build1) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 22:01:47 +0000

dose3 (3.1.3-7) unstable; urgency=low

  * patch ocaml-4.1-zip: fix _tags.in to avoid multiple pp options
    (closes: #731701).

 -- Ralf Treinen <treinen@debian.org>  Mon, 09 Dec 2013 21:32:31 +0100

dose3 (3.1.3-6) unstable; urgency=low

  * patch ocaml-4.1: fix FTBFS with ocaml 4.01. Thanks a lot to Pietro
    Abate for his help (closes: #731277)
  * Standards-version 3.9.5 (no change)

 -- Ralf Treinen <treinen@debian.org>  Fri, 06 Dec 2013 20:23:42 +0100

dose3 (3.1.3-5) unstable; urgency=low

  * debian/rules: "make clean" only when Makefile.config exists
    (closes: #723864)

 -- Ralf Treinen <treinen@debian.org>  Fri, 20 Sep 2013 21:19:25 +0200

dose3 (3.1.3-4) unstable; urgency=low

  * migrate doc/manpages/ceve.pod to the stricter format of pod2man from 
    perl 5.18.1 (closes: #719866).

 -- Ralf Treinen <treinen@debian.org>  Fri, 16 Aug 2013 18:52:15 +0200

dose3 (3.1.3-3) unstable; urgency=low

  * upload to unstable

 -- Ralf Treinen <treinen@debian.org>  Tue, 07 May 2013 20:41:52 +0200

dose3 (3.1.3-2) experimental; urgency=low

  * Fix FTBFS on architectures not supporting dynamic loading:
    - new patch configure-dynlink, provided by Mehdi Dogguy
    - debian/control: add build-dependency on automake, autoconf
    - debian/rules: dh_auto_configure calls aclocal and autoconf
  
 -- Ralf Treinen <treinen@debian.org>  Sun, 20 Jan 2013 17:34:42 +0100

dose3 (3.1.3-1) experimental; urgency=low

  * New upstream version. This version fixes the invocation of the clean
    target in doc/ makefiles (closes: #687651).
  * debian/{watch.copyright}: new location of upstream on gforge.inria.fr
  * dropped patches:
    - version-3.0.2 since upstream got the version right.
    - multiarch-conflicts (fixed by upstream)
    - apt-cudf-pinning (fixed by upstream)
    - builddebcheck-manpage (fixed by upstream)
  * we dont't have to call aclocal and autoconf any more (since patch 
    version-3.0.2 has been dropped), drop them from debian/rules and from
    the build-dependencies.
  * refreshed patch binaries-prefix-edos for the new upstream version
    (closes: #687576).
  * debian/rules, debian/dose-distcheck.{docs,doc-base}: the directory
    doc/debcheck-primer has been renamed to doc/debcheck.primer
  * patch doc-makefile-html: do not generate html version of man pages
  * Standards-Version 3.9.4 (no change).

 -- Ralf Treinen <treinen@debian.org>  Sun, 13 Jan 2013 21:57:55 +0100

=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 	dh $@ --with ocaml
 
 override_dh_auto_configure:
-	rm -f doc/debcheck-primer/version.tex
-	aclocal -I m4
-	autoconf
+	rm -f doc/debcheck.primer/version.tex
+	# use the following line when autoconf stuff is patched
+	aclocal -I m4 && autoconf
 	./configure --with-ocamlgraph --with-zip --with-bz2 --with-rpm4
 
 override_dh_auto_install:
@@ -33,12 +33,12 @@
 override_dh_auto_build:
 	dh_auto_build
 	$(MAKE) doc
-	cd doc/debcheck-primer && $(MAKE) 
+	cd doc/debcheck.primer && $(MAKE) 
 	pod2man --section 8 -release "apt-cudf $(RELEASE)" \
 		debian/update-cudf-solvers > debian/update-cudf-solvers.8
 
 override_dh_auto_clean:
-	dh_auto_clean
+	! [[ -f Makefile.config ]] || make distclean
 	rm -f debian/update-cudf-solvers.8
 	rm -f _tags

=== debian/watch ===
version=3
https://gforge.inria.fr/frs/?group_id=4395 .*/dose3-(.*)\.tar\.gz

## dose3 3.2.2

=== Makefile ===
--- 
+++ 
@@ -7,10 +7,10 @@
 DIST_TARBALL = $(DIST_DIR).tar.gz
 
 OBFLAGS := -j 10 -classic-display
-#OBFLAGS := $(OBFLAGS) -tag debug -tag profile
+#OBFLAGS := $(OBFLAGS) -tag profile -tag debug
 #OBFLAGS := $(OBFLAGS) -classic-display
 
-all: $(CAMLP4CMXS) $(BYTELIBS) $(ALIBS) $(OPTLIBS) $(CMXSLIBS) man
+all: $(CAMLP4CMXS) cleandoselib $(BYTELIBS) $(ALIBS) $(OPTLIBS) $(CMXSLIBS) man
 	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)
 
 fast: $(CAMLP4CMXS) $(OPTLIBS)
@@ -20,6 +20,9 @@
 	$(OCAMLBUILD) $(OBFLAGS) $(TARGETS)
 
 DOSELIBS = _build/doselibs
+
+cleandoselib:
+	rm -Rf $(DOSELIBS)
 
 camlp4cmxs:
 	mkdir -p _build
@@ -126,15 +129,14 @@
 	@touch $@
 
 testapps: apps 
-	@applications/dose-tests.py -pwd `pwd` -v
+	@applications/dose-tests.py applications/dose-tests.list
 
 testlib: 
 	@for i in $(TESTS); do\
-		echo "#######TESTING $$i" ;\
+		echo "\n#######START TESTING $$i" ;\
 		$(OCAMLBUILD) $(OBFLAGS) $$i/tests.$(OCAMLBEST) ;\
 		./tests.$(OCAMLBEST) ;\
 	done
-	@make apps
 
 test: testapps testlib
 
@@ -204,6 +206,6 @@
 
 upload: doc
 	(cd doc && $(MAKE) upload)
-	rsync -avz dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/
+	rsync -avz -O dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/api/
 
 .PHONY: all opt clean top-level headers test tags install uninstall dist doc man

=== doc/Makefile ===
SUBDIRS = manpages debcheck.primer apt-external-solvers.primer
SHELL=/bin/bash

all:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE)); \
	done

clean:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE) clean); \
	done

webpages:
	cd webpages && $(MAKE) rebuild

upload: webpages
	rsync -avz -O --no-perms manpages/*.html scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/man/
	rsync -avz -O --no-perms debcheck.primer/*.{html,pdf} scm.gforge.inria.fr:/home/groups/dose/htdocs/doc/tools/
	rsync -avz -O --no-perms webpages/public_html/* scm.gforge.inria.fr:/home/groups/dose/htdocs/public_html

=== debian/changelog ===
dose3 (3.2.2-2b1) staging; urgency=high

  * No-change rebuild against updated ocaml libraries

 -- Philip Muškovac <yofel@kubuntu.org>  Wed, 17 Sep 2014 15:11:35 +0000

dose3 (3.2.2-2) unstable; urgency=medium

  * patch buildcheck-manpage: extend explanation of the -e option of
    dose-builddebcheck (closes: #750078)
  * Add a transitional package for edos-distcheck. This makes the
    following source packages obsolete: pkglab, dose2.

 -- Ralf Treinen <rt@seneca.home.org>  Sun, 27 Jul 2014 20:48:31 +0200

dose3 (3.2.2-1) unstable; urgency=low

  * New upstream release.
  * Adapt patch binaries-prefix-edos, the target override_dh_installman
    in debian/rules, and debian/dose-extra.manpages to the new name of
    the debcoinstall manpage.

 -- Ralf Treinen <treinen@debian.org>  Tue, 27 May 2014 21:17:32 +0200

dose3 (3.2~rc3-1) experimental; urgency=low

  * New upstream release candidate
  * Install dose-deb-coinstall manpage
  * patch coinstall-binary-name: accept "dose-deb-coinstall" as alternative
    name of the coinstall binary.

 -- Ralf Treinen <treinen@debian.org>  Tue, 06 May 2014 20:00:50 +0200

dose3 (3.2~rc2-1) experimental; urgency=medium

  * New upstream release candidate.
  * Install deb-coinstall in the dose-extra package.

 -- Ralf Treinen <treinen@debian.org>  Sun, 04 May 2014 22:42:34 +0200

dose3 (3.2~rc1-1) experimental; urgency=low
  
  * New upstream release candidate. This release fixes a bug related to
    multiarch (closes: #727642)
  * Update build-dependency according to upstream's INSTALL instructions:
    - libocamlgraph-ocaml-dev: >= 1.8.5 (closes: #745307)		
    - replace libpcre-ocaml-dev by libre-ocaml-dev
    - bump libcudf to >= 0.7
    - drop automake, autoconf
  * debian/rules: don't run aclocal & autoconf
  * Drop debian patches that have become obsolete:
    - pod2man-5.18
    - configure-dynlink
    - ocaml-4.1
    - ocaml-4.1-zip
    - doc-makefile-html
  * Refreshed patches:
    - binaries-prefix-edos

 -- Ralf Treinen <treinen@debian.org>  Wed, 30 Apr 2014 20:02:59 +0200

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,16 @@
 Uploaders: Stefano Zacchiroli <zack@debian.org>,
  Ralf Treinen <treinen@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), dh-ocaml (>= 0.9~),
- automake, autoconf,
+# use the following line only when autoconf stuff has been patched:
+# automake, autoconf,
  ocaml-nox (>= 3.11.1-3~), camlp4,
- libpcre-ocaml-dev,
+ libre-ocaml-dev,
  libextlib-ocaml-dev,
- libocamlgraph-ocaml-dev,
- libcudf-ocaml-dev (>= 0.6.2),
+ libocamlgraph-ocaml-dev (>= 1.8.5),
+ libcudf-ocaml-dev (>= 0.7),
  libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.8),
  perl, graphviz, hevea, texlive-latex-base, texlive-latex-extra
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Homepage: http://www.mancoosi.org/software/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/dose3.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/dose3.git
@@ -101,6 +102,8 @@
   - dose-challenged, a debian-specific tool for checking which packages
     will certainly become uninstallable when some existing package is upgraded
     to a newer version.
+  - dose-coinstall, a debian-specific tool for checking whether a set of
+    packages can be installed all together.
  The tools dose-distcheck and dose-builddebcheck are packaged in their
  own resepective packages.
 
@@ -125,3 +128,12 @@
  .
  Several CUDF solvers are available in Debian. They all provide the cudf-solver
  virtual package.
+
+Package: edos-distcheck
+Section: oldlibs
+Priority: extra
+Architecture: all
+Depends: ${misc:Depends}, dose-distcheck, dose-builddebcheck
+Description: Checks dependencies of packages (transitional package)
+ This is a transitional package which can be safely removed, its only
+ purpose is to ease the transition to the dose3 tools.
